----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:44:05 10/24/2014 
-- Design Name: 
-- Module Name:    lab9demo - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity lab9demo is
    Port ( sw : in  STD_LOGIC_VECTOR (7 downto 0);
           clk : in  STD_LOGIC;
           Led : out  STD_LOGIC_VECTOR (7 downto 0));
end lab9demo;

architecture Behavioral of lab9demo is
-- declaration of KCPSM3 (always use this declaration to call
-- up PicoBlaze core)
component kcpsm3
port (address : out std_logic_vector(9 downto 0);
instruction : in std_logic_vector(17 downto 0);
port_id : out std_logic_vector(7 downto 0);
write_strobe : out std_logic;
out_port : out std_logic_vector(7 downto 0);
read_strobe : out std_logic;
in_port : in std_logic_vector(7 downto 0);
interrupt : in std_logic;
interrupt_ack : out std_logic;
reset : in std_logic;
clk : in std_logic);
end component;
-------------------------------------------------------------------------
-- declaration of program memory (here you will specify the entity name
-- as your .psm prefix name)
component demo
port (address : in std_logic_vector(9 downto 0);
instruction : out std_logic_vector(17 downto 0);
clk : in std_logic);
end component;
-------------------------------------------------------------------------
-- Signals used to connect PicoBlaze core to program memory and I/O logic
signal address : std_logic_vector(9 downto 0);
signal instruction : std_logic_vector(17 downto 0);
signal port_id : std_logic_vector(7 downto 0);
signal out_port : std_logic_vector(7 downto 0);
signal in_port : std_logic_vector(7 downto 0);
signal write_strobe : std_logic;
signal read_strobe : std_logic;
signal interrupt_ack : std_logic;
signal reset : std_logic;
-- the following input is assigned an inactive value since it is
-- unused in this example
signal interrupt : std_logic :='0';
-------------------------------------------------------------------------
-- Start of circuit description
begin
-- Instantiating the PicoBlaze core
processor: kcpsm3
port map (address => address,
instruction => instruction,
port_id => port_id,
write_strobe => write_strobe,
out_port => out_port,
read_strobe => read_strobe,
in_port => in_port,
interrupt => interrupt,
interrupt_ack => interrupt_ack,
reset => reset,
clk => clk);
-- Instantiating the program memory
program: pico
port map (address => address,
instruction => instruction,
clk => clk);
-- Connect I/O of PicoBlaze
------------------------------------------------------------------------
----- KCPSM3 Define input ports
------------------------------------------------------------------------
-- The inputs connect via a pipelined multiplexer
input_ports: process(clk)
begin
if clk'event and clk='1' then
case port_id(1 downto 0) is
-- read simple toggle switches and buttons at address 00 hex
when "00" =>
in_port <= sw;
-- Don't care used for all other addresses to ensure minimum
-- logic implementation
when others =>
in_port <= "XXXXXXXX";
end case;
end if;
end process input_ports;
------------------------------------------------------------------------
-- KCPSM3 Define output ports
------------------------------------------------------------------------
-- adding the output registers to the processor at address 80 hex
output_ports: process(clk)
begin
if clk'event and clk='1' then
if port_id(7)='1' then
Led <= out_port;
end if;
end if;
end process output_ports;
end Behavioral;

